<id>
Notify Once SP1.2/1.3/1.3.1
</id>

<version>
2.0 beta
</version>

<mod info>
Tired of receiving an email everytime someone replied to a message you're watching? Then try the new and improved "Notify Once"!
No longer will your inbox be flooded with almost identical emails - instead receive a single message saying one or more users have replied.


How to install:
1...Apply the mod file, upload the modified files.
2...Replace your existing Notify.pl file with the one supplied.

New in version 2.0:
1...Javascript confirmation added to notify links.
2...Board level notification of new topics.
3...Admin options to select [disable notification/notify on every post/notify once] for both reply and new topic notification.
4...Compatibility added with Poll mod and Rebuild Message Index.
5...Lots of other cosmetic and fun stuff!

Note:
This mod is incompatible with notify plus!
</mod info>

<author>
BHRA Webmaster
</author>

<homepage>
http://www.bhra.org.uk
</homepage>

###############################################################################

<edit file>
english.lng
</edit file>

<search for>
if($MenuType == 1) {
</search for>

<add before>
### Notify Once 2.0 ###
%bln_txt=(
	'01a',	"Topic Reply Notification",
	'01b',	"New Topic Notification",
	'02',	"Notify of new topics",
	'03',	"Would you like a notification Email if someone starts a new topic on this board\?",
	'04',	"Would you like to deactivate Notification of new topics on this board\?",
	'05',	"You are being notified of new topics in the following boards",
	'06a',	"A reply",
	'06b',	"has been posted by",
	'06c',	"to a topic you are watching.\n\nView it at",
	'07a',	"One or more replies have been posted to the topic",
	'07b',	"that you are watching.\n\nView it at",
	'08a',	"A new topic",
	'08b',	"has been posted by",
	'08c',	"to the board",
	'08d',	"that you are watching.\n\nView it at",
	'09a',	"One or more new topics have been posted to the board",
	'09b',	"that you are watching.\n\nView it at",
	'10',	"Enable Email Notification of Replies?",
	'11',	"Enable Board Level Notification of New Topics?",
	'12',	"None",
	'13',	"Notify of Every New Topic",
	'14',	"Notify Once",
	'15',	"a guest"
);
### Notify Once 2.0 ###

</add before>

<search for>
	$img{'notify'} = qq~<font size="1" class="imgcatbg">$txt{'131'}</font>~;
</search for>

<add after>
	$img{'notify_b'} = qq~<font size="1" class="imgcatbg">$bln_txt{'02'}</font>~;
</add after>

<search for>
	$img{'notify'} = qq~<img src="$imagesdir/notify.gif" alt="$txt{'131'}" border="0"> <font size="1" class="imgcatbg">$txt{'131'}</font>~;
</search for>

<add after>
	$img{'notify_b'} = qq~<img src="$imagesdir/notify.gif" alt="$bln_txt{'02'}" border="0"> <font size="1" class="imgcatbg">$bln_txt{'02'}</font>~;
</add after>

###############################################################################

<edit file>
Sources/AdminEdit.pl
</edit file>

<search for>
	if ($enable_notification) { $notifchecked = "checked" }
</search for>

<replace>
	if ($enable_notification == 1) { $ern1 = " selected" } elsif ($enable_notification == 2) { $ern2 = " selected" } else { $ern0 = " selected" }
	if ($enable_board_notify == 1) { $ebn1 = " selected" } elsif ($enable_board_notify == 2) { $ebn2 = " selected" } else { $ebn0 = " selected" }
</replace>

<search for>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$txt{'381'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=checkbox name="enable_notification" $notifchecked></td>
  </tr><tr>
</search for>

<replace>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$bln_txt{'10'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><select name="enable_notification" size="1">
      <option value="0"$ern0>$bln_txt{'12'}</option>
      <option value="1"$ern1>$bln_txt{'13'}</option>
      <option value="2"$ern2>$bln_txt{'14'}</option>
    </select></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$bln_txt{'11'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><select name="enable_board_notify" size="1">
      <option value="0"$ebn0>$bln_txt{'12'}</option>
      <option value="1"$ebn1>$bln_txt{'13'}</option>
      <option value="2"$ebn2>$bln_txt{'14'}</option>
    </select></td>
  </tr><tr>
</replace>

<search for>
	$timeselected = $FORM{'timeselect'} || 0;
</search for>

<add after>
	$enable_notification = $FORM{'enable_notification'} || 0;
	$enable_board_notify = $FORM{'enable_board_notify'} || 0;
</add after>

<search for>
\$enable_notification = $enable_notification;		# Allow e-mail notification
</search for>

<replace>
\$enable_notification = $enable_notification;		# Allow e-mail notification of replies (0=none, 1=notify of every reply, 2=notify once)
\$enable_board_notify = $enable_board_notify;		# Allow e-mail notification of new topics (0=none, 1=notify of every thread, 2=notify once)
</replace>

###############################################################################

<edit file>
sources/Display.pl
</edit file>

<search for>
	if($enable_notification) {
		my $startnum = $start || '0';
		$notify = qq~$menusep<a href="$cgi;action=notify;thread=$viewnum;start=$startnum">$img{'notify'}</a>~;
	}
</search for>

<replace>
	$notify = '';
	# Update notification file that the thread has been viewed.
	if($enable_notification && $username ne 'Guest') {
		my $startnum = $start || '0';
		$notify = qq~$menusep<a href="$cgi;action=notify2;thread=$viewnum;start=$startnum" onclick="javascript:return confirm('$txt{'126'}')">$img{'notify'}</a>~;
		if(-e("$datadir/$viewnum.mail"))  {
			my $i = 0;
			my $found = 0;
			fopen(FILE, "$datadir/$viewnum.mail");
			@mails = <FILE>;
			fclose(FILE);
			foreach $curmail (@mails) {
				chomp $curmail;
				($curmail, $mail_sent) = split(/\|/,$curmail);
				if ($curmail eq $settings[2]) {
					$notify = qq~$menusep<a href="$cgi;action=notify3;thread=$viewnum;start=$startnum" onclick="javascript:return confirm('$txt{'212'}')">$img{'notify'}</a>~;
					if ($mail_sent == 1) {$mail_sent = 0; $found = 1;}
				}
				$mails[$i] = "$curmail|$mail_sent\n";
				$i++;
			}
			if ($found == 1) {
				fopen(FILE, ">$datadir/$viewnum.mail");
				print FILE @mails;
				fclose(FILE);
			}
		}
	}

</replace>

###############################################################################

<edit file>
Sources/ManageBoards.pl
</edit file>

<search for>
		unlink("$boardsdir/$curboard.ctb");
</search for>

<add after>
		unlink("$boardsdir/$curboard.mail");
</add after>

###############################################################################

<edit file>
Sources/MessageIndex.pl
</edit file>

<search for>
	# Load censor list.
</search for>

<add before>
	$notify = '';
	# Update notification file that the board has been viewed.
	if($enable_board_notify && $username ne 'Guest') {
		$notify = qq~$menusep<a href="$cgi;action=notify2" onclick="javascript:return confirm('$bln_txt{'03'}')">$img{'notify_b'}</a>~;
		if(-e("$boardsdir/$currentboard.mail"))  {
			my $i = 0;
			my $found = 0;
			fopen(FILE, "$boardsdir/$currentboard.mail");
			@mails = <FILE>;
			fclose(FILE);
			foreach $curmail (@mails) {
				chomp $curmail;
				($curmail, $mail_sent) = split(/\|/,$curmail);
				if ($curmail eq $settings[2]) {
					$notify = qq~$menusep<a href="$cgi;action=notify3" onclick="javascript:return confirm('$bln_txt{'04'}')">$img{'notify_b'}</a>~;
					if ($mail_sent == 1) {$mail_sent = 0; $found = 1;}
				}
				$mails[$i] = "$curmail|$mail_sent\n";
				$i++;
			}
			if ($found == 1) {
				fopen(FILE, ">$boardsdir/$currentboard.mail");
				print FILE @mails;
				fclose(FILE);
			}
		}
	}

</add before>

<search for>
if($showmarkread) {
	$yymain .= qq~<a href="$cgi;action=markasread">$img{'markboardread'}</a>~;
}
</search for>

<add after>
if($enable_board_notify) {
	$yymain .= $notify;
}
</add after>

<search for>
	if($showmarkread) { $yymain .= qq~<a href="$cgi;action=markasread">$img{'markboardread'}</a>~; }
</search for>

<add after>
	if($enable_board_notify) { $yymain .= $notify; }
</add after>

###############################################################################

<edit file>
Sources/Post.pl
</edit file>

<search for>
	# Notify any members who have notification turned on for this thread.
	if(-e("$datadir/$thread.mail")) { &NotifyUsers; }
</search for>

<replace>
	# Notify any members who have notification turned on for this thread.
	if($threadid && -e("$datadir/$threadid.mail")) {if ($enable_notification eq "2") {&NotifyUsers("$datadir/$threadid.mail", "$msub", 0, $mreplies); } elsif ($enable_notification eq "1") { &NotifyUsers("$datadir/$threadid.mail", "$subject", 0, $mreplies); }}
	elsif($enable_board_notify && $newthreadid && -e("$boardsdir/$currentboard.mail")) { &NotifyUsers("$boardsdir/$currentboard.mail", "$subject", 1, 0); }
</replace>

<search for>
sub NotifyUsers {
	$subject = $FORM{'subject'};

	fopen(FILE, "$datadir/$thread.mail") || return 0;
	@mails = <FILE>;
	fclose(FILE);
	foreach $curmail (@mails) {
		chomp $curmail;
		if ($curmail ne $settings[2]) {
			&sendmail($curmail,"$txt{'127'}\:  $subject","$txt{'128'}, $subject, $txt{'129'} $cgi;action=display;num=$thread\n\n$txt{'130'}");
		}
	}
	return 1;
}
</search for>

<replace>
sub NotifyUsers {
	my $tmp_filename = $_[0];
	my $tmp_subject = $_[1];
	my $tmp_board_notify = $_[2];
	my $tmp_reply = $_[3] || 0;
	my $tmp_name = $settings[1] || $bln_txt{'15'};
	if ($tmp_board_notify) {
		fopen(FILE, "$boardsdir/$currentboard.dat");
		$bname = <FILE>;
		fclose(FILE);
		chomp $bname;
		if ($enable_board_notify == 1) {
			# Notify of every new thread
			$tmp_email_subject = "$bln_txt{'01b'}\: $tmp_subject";
			$tmp_email_message = "$bln_txt{'08a'}, \"$tmp_subject\", $bln_txt{'08b'} $tmp_name $bln_txt{'08c'} \"$bname\" $bln_txt{'08d'} $cgi;action=display;num=$thread\n\n$txt{'130'}";
		} elsif ($enable_board_notify == 2) {
			# Notify once of new threads
			$tmp_email_subject = "$bln_txt{'01b'}";
			$tmp_email_message = "$bln_txt{'09a'} \"$bname\" $bln_txt{'09b'} $cgi\n\n$txt{'130'}";
		}
	} else {
		if ($enable_notification == 1) {
			# Notify of every new reply
			$tmp_email_subject = "$bln_txt{'01a'}\: $tmp_subject";
			$tmp_email_message = "$bln_txt{'06a'}, \"$tmp_subject\", $bln_txt{'06b'} $tmp_name $bln_txt{'06c'} $cgi;action=display;num=$thread;start=$tmp_reply\n\n$txt{'130'}";
		} elsif ($enable_notification == 2) {
			# Notify once of new replies
			$tmp_email_subject = "$bln_txt{'01a'}";
			$tmp_email_message = "$bln_txt{'07a'}, \"$tmp_subject\", $bln_txt{'07b'} $cgi;action=display;num=$thread\n\n$txt{'130'}";
		}
	}

	fopen(FILE, "$tmp_filename") || return 0;
	@mails = <FILE>;
	fclose(FILE);
	my $i = 0;
	my $found = 0;
	foreach $curmail (@mails) {
		chomp $curmail;
		($curmail, $mail_sent) = split(/\|/,$curmail);
		if (($tmp_board_notify && $enable_board_notify == 1) || (!$tmp_board_notify && $enable_notification == 1)) {$mail_sent = 0;}
		if ($curmail ne $settings[2] && $mail_sent != 1) {
			&sendmail($curmail,"$tmp_email_subject","$tmp_email_message");
			$mail_sent = 1; $found = 1;
		}
		$mails[$i] = "$curmail|$mail_sent\n";
		$i++;
	}
	if ($found == 1) {
		fopen(FILE, ">$tmp_filename");
		print FILE @mails;
		fclose(FILE);
	}
	return 1;
}
</replace>

